<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'IdTagInfo' => '\\StructType\\IdTagInfo',
            'AuthorizeRequest' => '\\StructType\\AuthorizeRequest',
            'AuthorizeResponse' => '\\StructType\\AuthorizeResponse',
            'StartTransactionRequest' => '\\StructType\\StartTransactionRequest',
            'StartTransactionResponse' => '\\StructType\\StartTransactionResponse',
            'TransactionData' => '\\StructType\\TransactionData',
            'StopTransactionRequest' => '\\StructType\\StopTransactionRequest',
            'StopTransactionResponse' => '\\StructType\\StopTransactionResponse',
            'HeartbeatRequest' => '\\StructType\\HeartbeatRequest',
            'HeartbeatResponse' => '\\StructType\\HeartbeatResponse',
            'MeterValue' => '\\StructType\\MeterValue',
            'value' => '\\StructType\\Value',
            'MeterValuesRequest' => '\\StructType\\MeterValuesRequest',
            'MeterValuesResponse' => '\\StructType\\MeterValuesResponse',
            'BootNotificationRequest' => '\\StructType\\BootNotificationRequest',
            'BootNotificationResponse' => '\\StructType\\BootNotificationResponse',
            'StatusNotificationRequest' => '\\StructType\\StatusNotificationRequest',
            'StatusNotificationResponse' => '\\StructType\\StatusNotificationResponse',
            'FirmwareStatusNotificationRequest' => '\\StructType\\FirmwareStatusNotificationRequest',
            'FirmwareStatusNotificationResponse' => '\\StructType\\FirmwareStatusNotificationResponse',
            'DiagnosticsStatusNotificationRequest' => '\\StructType\\DiagnosticsStatusNotificationRequest',
            'DiagnosticsStatusNotificationResponse' => '\\StructType\\DiagnosticsStatusNotificationResponse',
            'DataTransferRequest' => '\\StructType\\DataTransferRequest',
            'DataTransferResponse' => '\\StructType\\DataTransferResponse',
        );
    }
}
