<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for value StructType
 * @subpackage Structs
 */
class Value extends AbstractStructBase
{
    /**
     * The _
     * @var string
     */
    public $_;
    /**
     * The context
     * Meta information extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $context;
    /**
     * The format
     * Meta information extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $format;
    /**
     * The measurand
     * Meta information extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $measurand;
    /**
     * The location
     * Meta information extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $location;
    /**
     * The unit
     * Meta information extracted from the WSDL
     * - use: optional
     * @var string
     */
    public $unit;
    /**
     * Constructor method for value
     * @uses Value::set_()
     * @uses Value::setContext()
     * @uses Value::setFormat()
     * @uses Value::setMeasurand()
     * @uses Value::setLocation()
     * @uses Value::setUnit()
     * @param string $_
     * @param string $context
     * @param string $format
     * @param string $measurand
     * @param string $location
     * @param string $unit
     */
    public function __construct($_ = null, $context = null, $format = null, $measurand = null, $location = null, $unit = null)
    {
        $this
            ->set_($_)
            ->setContext($context)
            ->setFormat($format)
            ->setMeasurand($measurand)
            ->setLocation($location)
            ->setUnit($unit);
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \StructType\Value
     */
    public function set_($_ = null)
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_, true), gettype($_)), __LINE__);
        }
        $this->_ = $_;
        return $this;
    }
    /**
     * Get context value
     * @return string|null
     */
    public function getContext()
    {
        return $this->context;
    }
    /**
     * Set context value
     * @uses \EnumType\ReadingContext::valueIsValid()
     * @uses \EnumType\ReadingContext::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $context
     * @return \StructType\Value
     */
    public function setContext($context = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ReadingContext::valueIsValid($context)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ReadingContext', is_array($context) ? implode(', ', $context) : var_export($context, true), implode(', ', \EnumType\ReadingContext::getValidValues())), __LINE__);
        }
        $this->context = $context;
        return $this;
    }
    /**
     * Get format value
     * @return string|null
     */
    public function getFormat()
    {
        return $this->format;
    }
    /**
     * Set format value
     * @uses \EnumType\ValueFormat::valueIsValid()
     * @uses \EnumType\ValueFormat::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $format
     * @return \StructType\Value
     */
    public function setFormat($format = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ValueFormat::valueIsValid($format)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\ValueFormat', is_array($format) ? implode(', ', $format) : var_export($format, true), implode(', ', \EnumType\ValueFormat::getValidValues())), __LINE__);
        }
        $this->format = $format;
        return $this;
    }
    /**
     * Get measurand value
     * @return string|null
     */
    public function getMeasurand()
    {
        return $this->measurand;
    }
    /**
     * Set measurand value
     * @uses \EnumType\Measurand::valueIsValid()
     * @uses \EnumType\Measurand::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $measurand
     * @return \StructType\Value
     */
    public function setMeasurand($measurand = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\Measurand::valueIsValid($measurand)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\Measurand', is_array($measurand) ? implode(', ', $measurand) : var_export($measurand, true), implode(', ', \EnumType\Measurand::getValidValues())), __LINE__);
        }
        $this->measurand = $measurand;
        return $this;
    }
    /**
     * Get location value
     * @return string|null
     */
    public function getLocation()
    {
        return $this->location;
    }
    /**
     * Set location value
     * @uses \EnumType\Location::valueIsValid()
     * @uses \EnumType\Location::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $location
     * @return \StructType\Value
     */
    public function setLocation($location = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\Location::valueIsValid($location)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\Location', is_array($location) ? implode(', ', $location) : var_export($location, true), implode(', ', \EnumType\Location::getValidValues())), __LINE__);
        }
        $this->location = $location;
        return $this;
    }
    /**
     * Get unit value
     * @return string|null
     */
    public function getUnit()
    {
        return $this->unit;
    }
    /**
     * Set unit value
     * @uses \EnumType\UnitOfMeasure::valueIsValid()
     * @uses \EnumType\UnitOfMeasure::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $unit
     * @return \StructType\Value
     */
    public function setUnit($unit = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\UnitOfMeasure::valueIsValid($unit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\UnitOfMeasure', is_array($unit) ? implode(', ', $unit) : var_export($unit, true), implode(', ', \EnumType\UnitOfMeasure::getValidValues())), __LINE__);
        }
        $this->unit = $unit;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Value
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
